Unit RSC2C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, FTFTC_p;

procedure RSC2C(var AR :Array of Real; var AI :Array of Real;
                var BR :Array of Real; var BI :Array of Real;
                N1 :Integer; N2 :Integer; L :Integer);

implementation

procedure RSC2C(var AR :Array of Real; var AI :Array of Real;
                var BR :Array of Real; var BI :Array of Real;
                N1 :Integer; N2 :Integer; L :Integer);
var
I,J :Integer;
Q,R1,R2,R3,R4 :Real;
label
_10,_20,_30,_40;
begin
Q  := 1.0;
case L of
 1: goto _10;
 2: goto _20;
end;
_10:
FTFTC(AR,AI,N1,N2,Q);
_20:
FTFTC(BR,BI,N1,N2,Q);
Q  := 1.0/(N1*N2);
for I:=1 to N1 do
 begin
  for J:=1 to N2 do
   begin
    R1  := AR[(I-1)+(J-1)*N1];
    R2  := AI[(I-1)+(J-1)*N1];
    R3  := BR[(I-1)+(J-1)*N1];
    R4  := BI[(I-1)+(J-1)*N1];
    BR[(I-1)+(J-1)*N1] := (R1*R3 - R2*R4)*Q;
    BI[(I-1)+(J-1)*N1] := (R1*R4 + R2*R3)*Q;
_30:
   end;
_40:
 end;
Q  := -1.0;
FTFTC(BR,BI,N1,N2,Q);
end;

end.
